//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

//--------------------------------------------------------------------------
// FILTERLIB FUNCTIONS
//--------------------------------------------------------------------------

#include <tigcclib.h>         // Include All Header Files
#include "filterlib.h"

int (*IsFilterSym)(SYM_ENTRY*SymPtr);

//---------------------------------------------------------------------------

int FileExists(char*filename) 
{
return (SymFind(SYMSTR(filename)).folder);
}
//--------------------------------------------------------------------------

int FileLength(char*filename) 
{
return (*(unsigned short*)(HeapDeref((DerefSym(SymFind(SYMSTR(filename))))->handle)));
}
//--------------------------------------------------------------------------

unsigned char* FilePointer(char*filename) 
{
return ((unsigned char*)(HeapDeref((DerefSym(SymFind(SYMSTR(filename))))->handle))+2);
}
//--------------------------------------------------------------------------

unsigned char*SymPtrAdress(SYM_ENTRY*SymPtr)
{
return ((unsigned char*)(HeapDeref(SymPtr->handle))+2);
}
//--------------------------------------------------------------------------

SYM_ENTRY*SymFindFirstF(void)
{

SYM_ENTRY*SymPtr;
SymPtr=SymFindFirst ($(main), 1);
while(SymPtr && !IsFilterSym(SymPtr))
SymPtr=SymFindNext();
return SymPtr;

}
//---------------------------------------------------------------------------

SYM_ENTRY*SymFindNextF(void)
{

SYM_ENTRY*SymPtr;
do
{
SymPtr=SymFindNext();
}
while(SymPtr && !IsFilterSym(SymPtr));

if (!SymPtr)
SymPtr=SymFindFirstF();

return SymPtr;

}
//---------------------------------------------------------------------------

SYM_ENTRY*SymFindPrevF(void)
{

SYM_ENTRY*SymPtr;
do
{
SymPtr=SymFindPrev();
}
while(SymPtr && !IsFilterSym(SymPtr));

if (!SymPtr)
SymPtr=SymFindFirstF();

return SymPtr;

}
//---------------------------------------------------------------------------
